#include<stdio.h>
#include<stdlib.h>
#include<time.h>



void rand_vec_generate(long v[],long n){
 long i;
 for (i=0;i<n;i++) v[i]=lrand48();
}

  
void insertion_sort(long v[],long sz){
 long i,j,x;

 for (i=1;i<sz;i++){
  x=v[i];
  for (j=i-1;j>=0;j--){
    if (x>=v[j]) break;
    v[j+1]=v[j];
  }
  v[j+1]=x;
 }
}

void getparms(char *argv[],long *i,long *j,long *k){
 sscanf(argv[1],"%d",i);
 sscanf(argv[2],"%d",j);
 sscanf(argv[3],"%d",k);
}

long **getvecs(long tot,long sz){
 long i,**v;
 v = (long **) malloc(sizeof(long*)*tot);
 for (i=0;i<tot;i++){
  v[i]=(long*) malloc(sizeof(long)*sz);
  rand_vec_generate(v[i],sz);
 }
 return v;
}   


int main(int argc, char *argv[]){
  long **v,**u,tot_sm_vs,sm_v_sz,big_v_sz,i;
  clock_t t0,t1,t2,t3;

  getparms(argv,&tot_sm_vs,&sm_v_sz,&big_v_sz);

  v=getvecs(tot_sm_vs,sm_v_sz);
  u=getvecs(1,big_v_sz);


/*   for(i=0;i<big_v_sz;i++) printf("i:%d:%d\n",i,u[0][i]); */
/*   insertion_sort(u[0],big_v_sz); */
/*   for(i=0;i<sm_v_sz;i++) printf("i:%d:%d\n",i,u[0][i]); */
 
  t0 = clock();
  for (i=0;i<tot_sm_vs;i++) insertion_sort(v[i],sm_v_sz);
  t1 = clock();
  
  printf("%d:%d:%d:%d\n",tot_sm_vs*sm_v_sz,t0,t1,t1-t0);
 
  t2 = clock();
  insertion_sort(u[0],big_v_sz);
  t3 = clock();
  
  printf("%d:%d:%d:%d\n",big_v_sz,t2,t3,t3-t2);

 
}
