#include<stdio.h>
#include<stdlib.h>
#include<time.h>


#ifdef _DEBUG_
void rand_vec_generate(long v[],long n){
 long i;
 for (i=0;i<n;i++) scanf("%d",v+i);
}
#else
void rand_vec_generate(long v[],long n){
 long i;
 for (i=0;i<n;i++) v[i]=lrand48();
}
#endif

#define swap(v,i,j) {int t; t=v[i];v[i]=v[j];v[j]=t;}
void sift(long v[],long l,long r){
 long j=2*l;

 if (j<r && v[j+1]>v[j]) j++;
 while (j<=r){
   if (v[l]<v[j]) swap(v,j,l)
  else break;
  l=j;
  j<<=1;
  if (j<r && v[j+1]>v[j]) j++;
 }
}
  
void heap_sort(long v[],long sz){
 long i,j,x;

 for (i=sz/2;i>=0;i--) sift(v,i,sz-1);
 for (i=sz-1;i>0;i--){
  swap(v,0,i);
  if (i>1) sift(v,0,i-1);
 }
}

void getparms(char *argv[],long *i,long *j,long *k){
 sscanf(argv[1],"%d",i);
 sscanf(argv[2],"%d",j);
 sscanf(argv[3],"%d",k);
}

long **getvecs(long tot,long sz){
 long i,**v;
 v = (long **) malloc(sizeof(long*)*tot);
 for (i=0;i<tot;i++){
  v[i]=(long*) malloc(sizeof(long)*sz);
  rand_vec_generate(v[i],sz);
 }
 return v;
}   


int main(int argc, char *argv[]){
  long **v,**u,tot_sm_vs,sm_v_sz,big_v_sz,i;
  clock_t t0,t1,t2,t3;

  getparms(argv,&tot_sm_vs,&sm_v_sz,&big_v_sz);

  v=getvecs(tot_sm_vs,sm_v_sz);
  u=getvecs(1,big_v_sz);


#if defined _DEBUG_||_DEBUG1_
  for(i=0;i<big_v_sz;i++) printf("i:%d:%d\n",i,u[0][i]);
  heap_sort(u[0],big_v_sz);
/*   for (i=big_v_sz/2;i>=0;i--) sift(u[0],i,big_v_sz-1); */
  for(i=0;i<big_v_sz;i++) printf("i:%d:%d\n",i,u[0][i]);
  exit(0);
#endif
 
  t0 = clock();
  for (i=0;i<tot_sm_vs;i++) heap_sort(v[i],sm_v_sz);
  t1 = clock();
  
  printf("%d:%d:%d:%d\n",tot_sm_vs*sm_v_sz,t0,t1,t1-t0);
 
  t2 = clock();
  heap_sort(u[0],big_v_sz);
  t3 = clock();
  
  printf("%d:%d:%d:%d\n",big_v_sz,t2,t3,t3-t2);

 
}
