#include<stdio.h>
#include<stdlib.h>
#include<time.h>

#define TOT_SMALL_VECS 200
#define SMALL_VEC_SZ 1000
#define BIG_VEC_SZ 20000

void rand_vec_generate(long v[],long n){
 long i;
 for (i=0;i<n;i++) v[i]=lrand48();
}

void insertion_sort(long v[],long sz){
 long i,j,x;

 for (i=1;i<sz;i++){
  x=v[i];
  for (j=i-1;j>=0;j--){
    if (x>=v[j]) break;
    v[j+1]=v[j];
  }
  v[j+1]=x;
 }
}

int main(int argc, char *argv[]){
  long v[TOT_SMALL_VECS][SMALL_VEC_SZ],u[BIG_VEC_SZ],i;
  clock_t t0,t1,t2,t3;


  for (i=0;i<TOT_SMALL_VECS;i++) rand_vec_generate(v[i],SMALL_VEC_SZ);
  rand_vec_generate(u,BIG_VEC_SZ);

/*   for(i=0;i<SMALL_VEC_SZ;i++) printf("i:%d:%d\n",i,v[0][i]); */
/*   insertion_sort(v[0],SMALL_VEC_SZ); */
/*   for(i=0;i<SMALL_VEC_SZ;i++) printf("i:%d:%d\n",i,v[0][i]); */
 
  t0 = clock();
  for (i=0;i<TOT_SMALL_VECS;i++) insertion_sort(v[i],SMALL_VEC_SZ);
  t1 = clock();
  
  printf("%d:%d:%d\n",t0,t1,t1-t0);
 
  t2 = clock();
  insertion_sort(u,BIG_VEC_SZ);
  t3 = clock();
  
  printf("%d:%d:%d\n",t2,t3,t3-t2);

 
}
